<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from lic.texi on 28 April 1999 -->

<TITLE>The Linear Inequality Calculator - Calculator Syntax</TITLE>
<link href="lic_19.html" rel=Next>
<link href="lic_17.html" rel=Previous>
<link href="lic_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_17.html">previous</A>, <A HREF="lic_19.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC18" HREF="lic_toc.html#TOC18">Calculator Syntax</A></H2>
<P>
<A NAME="IDX187"></A>
<A NAME="IDX188"></A>

</P>

<P>
In this mode, <CODE>LIC</CODE> can handle matrix and linear inequality
operations as well as integer operations.

<UL>
<LI>

Simple arithmetic operations are available for both integers and linear
inequalities. 
(<CODE>'+'   '-'   '*'   '/'</CODE>)
<A NAME="IDX189"></A>
<A NAME="IDX190"></A>
<A NAME="IDX191"></A>
<A NAME="IDX192"></A>

<LI>

User defined variables are available in <CODE>LIC</CODE>.  The type of the
variable is either integer or matrix (same as linear inequalities)
depending on the first assignment 
to the variable (use of a variable without first assigning to it is of
course illegal). 
The names of the variables can be any combination of alphabetic
characters except for reserved keywords.
<DL COMPACT>

<DT><CODE>n = 4</CODE>
<DD>
<DT><CODE>A = ident(n)*A</CODE>
<DD>
</DL>

<LI>

You can directly create a matrix and assign a value to each of the
elements. A matrix is created by delimiting the body of the matrix by
square brackets(<SAMP>`[...]'</SAMP>). Elements of a row are separated by a
comma(<SAMP>`,'</SAMP>) except for the last element. Each element can be an
integer or a variable (with an integer assigned to it).

<PRE>
   [ 0,   1,   2
     0&#60;3&#62;                                          
     0,  -1,   3 ]
</PRE>

<A NAME="IDX193"></A>
Note that <SAMP>`0&#60;3&#62;'</SAMP> is same as <SAMP>`0, 0, 0'</SAMP>
<A NAME="IDX194"></A>
<A NAME="IDX195"></A>
<A NAME="IDX196"></A>
<A NAME="IDX197"></A>
<A NAME="IDX198"></A>

<LI>

You can also create a matrix by composing multiple matrices together.
This operator is similar to the <SAMP>`Compose'</SAMP> function in the section
on Matrix Manipulation in the SUIFMATH Library Reference Manual.

<PRE>
   { A, ., B                                      
     ., C, D }
</PRE>

<A NAME="IDX199"></A>
Note that <SAMP>`<SAMP>`.'</SAMP>'</SAMP> is a matrix with 0's 
<A NAME="IDX200"></A>
<A NAME="IDX201"></A>
<A NAME="IDX202"></A>
<A NAME="IDX203"></A>
<A NAME="IDX204"></A>

<LI>

You can directly create a set of inequalities in <CODE>LIC</CODE>.  When
creating inequalities, each dimension is assigned a number which is the
column number in the final matrix. For example, the dimension 3 is
represented by <SAMP>`@3'</SAMP>. An inequality is delimited by an exclamation
mark <SAMP>`!...!'</SAMP>. Within the delimiters, any mathematical
expression of integers, integer variables and dimension symbols is
valid, as long as the resulting inequality is a linear function of the
dimensions.  Any of the operators <SAMP>`=, ==, &#62;, &#62;=, &#60;, &#60;='</SAMP> can be used
to construct an inequality. Some combination of two operators such as
<VAR>a &#60;= b &#60; c</VAR> are also valid.
<DL COMPACT>

<DT><CODE>parse(inequality)</CODE>
<DD>
<DT><CODE>!inequality!</CODE>
<DD>
</DL>
For example, the following input: <VAR>! 1 + 2(2@2 - 4@5) &#62;= 0 !</VAR>
results in:  <CODE>[ 1   0   4   0   0  -8 ]</CODE>
<A NAME="IDX205"></A>
<A NAME="IDX206"></A>
<A NAME="IDX207"></A>
<A NAME="IDX208"></A>
<A NAME="IDX209"></A>
<A NAME="IDX210"></A>
<A NAME="IDX211"></A>
<A NAME="IDX212"></A>
<A NAME="IDX213"></A>
<A NAME="IDX214"></A>

<BLOCKQUOTE>
<P>
Let us look at how to convert the following inequalities into this format.

<UL>
<LI>V = 1000

<LI>1 &#60;= i1 &#60;= V

<LI>1 &#60;= i2 &#60;= U

<LI>32*p1 &#60;= i1-1 &#60; 32 + 32*p1

<LI>32*p2 &#60;= 12-1 &#60; 32 + 32*p2

</UL>

<P>
When writing inequalities, the dimensions should be identified, ordered
and numbered. For example, the following list is a list of dimensions
and the corresponding numbers for the above example

<PRE>
Dimension:   U     p1     p2     i1     i2
Number:      1      2      3      4      5
</PRE>

<A NAME="IDX215"></A>
<P>
Next we can create the above set of inequalities:

<PRE>
V = 1000
ineq = { !1 &#60;= @4 &#60;= V!
         !1 &#60;= @5 &#60;= @1!
         !32@2 &#60;= @4 - 1 &#60; 32 + 32@2!
         !32@3 &#60;= @5 - 1 &#60; 32 + 32@3! }
</PRE>

<A NAME="IDX216"></A>
<P>
The resulting system of inequalities is

<PRE>
   1000      0      0      0     -1      0
     -1      0      0      0      1      0
      0      1      0      0      0     -1
     -1      0      0      0      0      1
     32      0     32      0     -1      0
     -1      0    -32      0      1      0
     32      0      0     32      0     -1
     -1      0      0    -32      0      1
</PRE>

<A NAME="IDX217"></A>
</BLOCKQUOTE>

<LI>

Many other functions associated with matrices and linear inequalities
can be used directly from <CODE>LIC</CODE>.  When more than one function is
listed below, they are all equivalent.  The available function calls
are:
<DL COMPACT>

<DT><CODE>identity(n)</CODE>
<DD>
<DT><CODE>ident(n)</CODE>
<DD>
<DT><CODE>id(n)</CODE>
<DD>
<BR> Create an identity matrix
<A NAME="IDX218"></A>
<A NAME="IDX219"></A>
<A NAME="IDX220"></A>
<A NAME="IDX221"></A>

<DT><CODE>M.solve()</CODE>
<DD>
<DT><CODE>solve(M)</CODE>
<DD>
<DT><CODE>M.solve</CODE>
<DD>
<DT><CODE>M.s()</CODE>
<DD>
<DT><CODE>s(M)</CODE>
<DD>
<DT><CODE>M.s</CODE>
<DD>
<BR> Solve the set of inequalities by Fourier-Motzkin elimination
<A NAME="IDX222"></A>
<A NAME="IDX223"></A>

<DT><CODE>filterthru(M, F, s)</CODE>
<DD>
<DT><CODE>M.filterthru(F, s)</CODE>
<DD>
<DT><CODE>ft(M, F, s)</CODE>
<DD>
<DT><CODE>M.ft(F, s)</CODE>
<DD>
<BR> Filter through the Matrix <VAR>M</VAR> using Filter <VAR>F</VAR>, and the sign
<VAR>s</VAR>. 
<A NAME="IDX224"></A>
<A NAME="IDX225"></A>

<DT><CODE>filteraway(M, F, s)</CODE>
<DD>
<DT><CODE>M.filteraway(F, s)</CODE>
<DD>
<DT><CODE>fa(M, F, s)</CODE>
<DD>
<DT><CODE>M.fa(F, s)</CODE>
<DD>
<BR> Filter away the Matrix <VAR>M</VAR> using Filter <VAR>F</VAR>, and the sign <VAR>s</VAR>.
<A NAME="IDX226"></A>
<A NAME="IDX227"></A>

<DT><CODE>row_swap(M, i, j)</CODE>
<DD>
<DT><CODE>M.row_swap(i, j)</CODE>
<DD>
<DT><CODE>rs(M, i, j)</CODE>
<DD>
<DT><CODE>M.rs(i, j)</CODE>
<DD>
<BR> Swap rows <VAR>i</VAR> and <VAR>j</VAR> of the matrix <VAR>M</VAR>.
<A NAME="IDX228"></A>
<A NAME="IDX229"></A>

<DT><CODE>col_swap(M, i, j)</CODE>
<DD>
<DT><CODE>M.col_swap(i, j)</CODE>
<DD>
<DT><CODE>cs(M, i, j)</CODE>
<DD>
<DT><CODE>M.cs(i, j)</CODE>
<DD>
<BR> Swap columns <VAR>i</VAR> and <VAR>j</VAR> of the matrix <VAR>M</VAR>.
<A NAME="IDX230"></A>
<A NAME="IDX231"></A>

<DT><CODE>row_del(M, i, j)</CODE>
<DD>
<DT><CODE>M.row_del(i, j)</CODE>
<DD>
<DT><CODE>row_del(M, i)</CODE>
<DD>
<DT><CODE>M.row_del(i)</CODE>
<DD>
<DT><CODE>rd(M, i, j)</CODE>
<DD>
<DT><CODE>M.rd(i, j)</CODE>
<DD>
<DT><CODE>rd(M, i)</CODE>
<DD>
<DT><CODE>M.rd(i)</CODE>
<DD>
<BR> Delete row(s) of the matrix <VAR>M</VAR>
<A NAME="IDX232"></A>
<A NAME="IDX233"></A>

<DT><CODE>col_del(M, i, j)</CODE>
<DD>
<DT><CODE>M.col_del(i, j)</CODE>
<DD>
<DT><CODE>col_del(M, i)</CODE>
<DD>
<DT><CODE>M.col_del(i)</CODE>
<DD>
<DT><CODE>cd(M, i, j)</CODE>
<DD>
<DT><CODE>M.cd(i, j)</CODE>
<DD>
<DT><CODE>cd(M, i)</CODE>
<DD>
<DT><CODE>M.cd(i)</CODE>
<DD>
<BR> Delete columns(s) of the matrix <VAR>M</VAR>.
<A NAME="IDX234"></A>
<A NAME="IDX235"></A>

<DT><CODE>col_ins(M, i)</CODE>
<DD>
<DT><CODE>M.col_ins(i)</CODE>
<DD>
<DT><CODE>ci(M, i)</CODE>
<DD>
<DT><CODE>M.ci(i)</CODE>
<DD>
<BR> Insert column of the matrix <VAR>M</VAR>.
<A NAME="IDX236"></A>
<A NAME="IDX237"></A>

<DT><CODE>M.inverse()</CODE>
<DD>
<DT><CODE>inverse(M)</CODE>
<DD>
<DT><CODE>M.inverse</CODE>
<DD>
<DT><CODE>M.inv()</CODE>
<DD>
<DT><CODE>inv(M)</CODE>
<DD>
<DT><CODE>M.inv</CODE>
<DD>
<BR> Find the inverse of a matrix <VAR>M</VAR>.
<A NAME="IDX238"></A>
<A NAME="IDX239"></A>

<DT><CODE>M.transpose()</CODE>
<DD>
<DT><CODE>transpose(M)</CODE>
<DD>
<DT><CODE>M.transpose</CODE>
<DD>
<DT><CODE>M.t()</CODE>
<DD>
<DT><CODE>t(M)</CODE>
<DD>
<DT><CODE>M.t</CODE>
<DD>
<BR> Find the transpose of a matrix <VAR>M</VAR>
<A NAME="IDX240"></A>
<A NAME="IDX241"></A>

<DT><CODE>M.code(namelist)</CODE>
<DD>
<BR> Print code corresponding to a set of inequalities.
<VAR>namelist</VAR> is of the form <VAR>i, j, k</VAR> where the items are named
columns 1 to last. See section <A HREF="lic_19.html#SEC19">Calculator Example</A> for a use of this function.
<A NAME="IDX242"></A>
</DL>
</UL>

<P><HR><P>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_17.html">previous</A>, <A HREF="lic_19.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
</BODY>
</HTML>
